#include	<stdio.h>
#include	"defs.h"
#include	"global.h"

#define	PXLID		1001

#define	NHALFPXLCHARS	128
#define	NPXLCHARS	256	/* <= NFNTCHARS */

ReadPXLFontInfo(fe, fntfp)
register struct font_entry *fe;
register FILE *fntfp;
{
    int t, i, fdir, nchars;
    register struct char_entry *tcharptr;/* temporary char_entry pointer  */
    
    if ((t = NoSignExtend(fntfp, 4)) != PXLID)
    {
	fprintf(stderr, "PXL ID = %d, can only process PXL ID = %d files\n", t, PXLID);
	exit(1);
    }
    fseek(fntfp, -20, 2);
    t = NoSignExtend(fntfp, 4);
    if ((fe->c != 0) && (t != 0) && (fe->c != t))
	fprintf(stderr, "font = \"%s\",\n-->font checksum = %d,\n-->dvi checksum = %d\n", fe->name, fe->c, t);
    fe->magnification = NoSignExtend(fntfp, 4);
    fe->designsize = NoSignExtend(fntfp, 4);
    
    t = ftell(fntfp) - 12;
    fseek(fntfp, fdir = NoSignExtend(fntfp, 4) * 4, 0);
    nchars = (t-fdir)/(4*4);
    if(nchars > NPXLCHARS)
    {
	fprintf(stderr, "font dir size of %s is %d\n", fe->name, nchars);
	exit(1);
    }
    else if (nchars != NHALFPXLCHARS && nchars != NPXLCHARS)
    {
	fprintf(stderr, "font dir size of %s is %d\n", fe->name, nchars);
    }
    fe->nfntchars = nchars;
    
    for (i = 0; i < nchars; i++) {
	tcharptr = &(fe->ch[i]);
	tcharptr->width = NoSignExtend(fntfp, 2);
	tcharptr->height = NoSignExtend(fntfp, 2);
	tcharptr->xOffset = SignExtend(fntfp, 2);
	tcharptr->yOffset = SignExtend(fntfp, 2);
	tcharptr->nbpl = ((tcharptr->width + 31) >> 5) * 4;
	if((tcharptr->where.fileOffset = NoSignExtend(fntfp, 4) * 4) == 0)
	    tcharptr->where.fileOffset = NONEXISTANT;
	tcharptr->tfmw = ((float)NoSignExtend(fntfp, 4)*(float)fe->s) /
	    (float)(1<<20);
    }
}

loadpxlchar(fe, c)
register struct font_entry *fe;
int c;
{
    char *pixel;
    int nbytes;
    register struct char_entry *ce;
    FILE *pxlfp;
    
    ce = &(fe->ch[c]);
    OpenFontFile(fe);
    fseek(pxlfp = fe->font_file_id, ce->where.fileOffset, 0);
    nbytes = ce->nbpl * ce->height;
    if((pixel = (char *)malloc(nbytes)) == NULL )
    {
	fprintf(stderr, "Unable to allocate memory for char\n");
	exit(1);
    }
    fread(pixel, 1, nbytes, pxlfp);
    ce->where.pixptr = pixel;
}
